#ifndef STT_CONFIG_H
#define STT_CONFIG_H

/* empty: do not depend on link-time inlines */
#define STT_INLINE

#ifndef FUNC_LOCALCTX_SIZE
#define FUNC_LOCALCTX_SIZE 32 /* number of slots in the local variable contexts of functions */
#endif
#ifndef FUNC_MAXPARMS
#define FUNC_MAXPARMS 32 /* maximum number of parameters a function can take. just use a list.. */
#endif

#define STT_EXIT_MEMORY_FAIL 1

#define SYMBOL_NAME_HASH_SIZE 8192

#ifndef STT_ARRAY_MAXDIMS
#define STT_ARRAY_MAXDIMS 4
#endif

#define STT_REUSABLE_INT_LIMIT 256 /* cache first N integer objects (unless DISABLE_INTCACHE is defined) */

#ifndef DICT_THRESHOLD
#define DICT_THRESHOLD 192
#endif

#ifndef DEFAULT_DICT_SIZE
#define DEFAULT_DICT_SIZE 8
#endif

/* size of stt_varctx_t for initarg, slotname lookups in classes */
#ifndef CLASS_NAMES_SIZE
#define	CLASS_NAMES_SIZE 32
#endif

#ifndef DEFAULT_DISPATCH_SIZE
#define DEFAULT_DISPATCH_SIZE 8
#endif

/* fill threshold of method dispatch table (/256) */
#ifndef DISPATCH_THRESHOLD
#define DISPATCH_THRESHOLD 128
#endif

/* perform GC each time after this many objects are allocated by default (can be overriden in stt_ctx_t) */
#define STT_GC_DEFAULT_ALLOC_LIMIT 8192

#define GC_GEN2_PERIOD 2 /* generation 2 is checked for each Nth check of generation 1 */
#define GC_GEN3_PERIOD 4 /* generation 3 is checked for each Nth check of generation 2 */

#endif
